ContentHandler (Java Platform SE 8 )
Keywords: java.net.ContentHandler class
Date: 2026-04-17

compact1, compact2, compact3
java.net

## Class ContentHandler

- java.lang.Object
- - java.net.ContentHandler

-     public abstract class ContentHandler
      extends Object

  The abstract class `ContentHandler` is the superclass of all classes that read an `Object` from a `URLConnection`.

  An application does not generally call the `getContent` method in this class directly. Instead, an application calls the `getContent` method in class `URL` or in `URLConnection`. The application's content handler factory (an instance of a class that implements the interface `ContentHandlerFactory` set up by a call to `setContentHandler`) is called with a `String` giving the MIME type of the object being received on the socket. The factory returns an instance of a subclass of `ContentHandler`, and its `getContent` method is called to create the object.

  If no content handler could be found, URLConnection will look for a content handler in a user-defineable set of places. By default it looks in sun.net.www.content, but users can define a vertical-bar delimited set of class prefixes to search through in addition by defining the java.content.handler.pkgs property. The class name must be of the form:

           {package-prefix}.{major}.{minor}
       e.g.
           YoyoDyne.experimental.text.plain

  If the loading of the content handler class would be performed by a classloader that is outside of the delegation chain of the caller, the JVM will need the RuntimePermission "getClassLoader".
  Since:
    JDK1.0
  See Also:
    `getContent(java.net.URLConnection)`, `ContentHandlerFactory`, `URL.getContent()`, `URLConnection`, `URLConnection.getContent()`, `URLConnection.setContentHandlerFactory(java.net.ContentHandlerFactory)`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ContentHandler()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract Object` | `getContent(URLConnection urlc)` Given a URL connect stream positioned at the beginning of the representation of an object, this method reads that stream and creates an object from it.
    `Object` | `getContent(URLConnection urlc, Class[] classes)` Given a URL connect stream positioned at the beginning of the representation of an object, this method reads that stream and creates an object that matches one of the types specified.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ContentHandler

          public ContentHandler()

  - ### Method Detail

    - #### getContent

          public abstract Object getContent(URLConnection urlc)
                                     throws IOException

      Given a URL connect stream positioned at the beginning of the representation of an object, this method reads that stream and creates an object from it.
      Parameters:
        `urlc` - a URL connection.
      Returns:
        the object read by the `ContentHandler`.
      Throws:
        `IOException` - if an I/O error occurs while reading the object.

    - #### getContent

          public Object getContent(URLConnection urlc,
                                   Class[] classes)
                            throws IOException

      Given a URL connect stream positioned at the beginning of the representation of an object, this method reads that stream and creates an object that matches one of the types specified. The default implementation of this method should call getContent() and screen the return type for a match of the suggested types.
      Parameters:
        `urlc` - a URL connection.
        `classes` - an array of types requested
      Returns:
        the object read by the `ContentHandler` that is the first match of the suggested types. null if none of the requested are supported.
      Throws:
        `IOException` - if an I/O error occurs while reading the object.
      Since:
        1.3

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.